/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package test.saveref;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see test.saveref.SaverefFactory
 * @model kind="package"
 * @generated
 */
public interface SaverefPackage extends EPackage {
    /**
     * The package name.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNAME = "saveref";

    /**
     * The package namespace URI.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNS_URI = "http://saveref";

    /**
     * The package namespace name.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    String eNS_PREFIX = "saveref";

    /**
     * The singleton instance of the package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    SaverefPackage eINSTANCE = test.saveref.impl.SaverefPackageImpl.init();

    /**
     * The meta object id for the '{@link test.saveref.impl.BookImpl <em>Book</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see test.saveref.impl.BookImpl
     * @see test.saveref.impl.SaverefPackageImpl#getBook()
     * @generated
     */
    int BOOK = 0;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK__NAME = 0;

    /**
     * The number of structural features of the '<em>Book</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int BOOK_FEATURE_COUNT = 1;

    /**
     * The meta object id for the '{@link test.saveref.impl.ScifiBookImpl <em>Scifi Book</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see test.saveref.impl.ScifiBookImpl
     * @see test.saveref.impl.SaverefPackageImpl#getScifiBook()
     * @generated
     */
    int SCIFI_BOOK = 1;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCIFI_BOOK__NAME = BOOK__NAME;

    /**
     * The feature id for the '<em><b>Authors</b></em>' reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCIFI_BOOK__AUTHORS = BOOK_FEATURE_COUNT + 0;

    /**
     * The number of structural features of the '<em>Scifi Book</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int SCIFI_BOOK_FEATURE_COUNT = BOOK_FEATURE_COUNT + 1;

    /**
     * The meta object id for the '{@link test.saveref.impl.AuthorImpl <em>Author</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see test.saveref.impl.AuthorImpl
     * @see test.saveref.impl.SaverefPackageImpl#getAuthor()
     * @generated
     */
    int AUTHOR = 2;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUTHOR__NAME = 0;

    /**
     * The number of structural features of the '<em>Author</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int AUTHOR_FEATURE_COUNT = 1;

    /**
     * The meta object id for the '{@link test.saveref.impl.ForeignAuthorImpl <em>Foreign Author</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see test.saveref.impl.ForeignAuthorImpl
     * @see test.saveref.impl.SaverefPackageImpl#getForeignAuthor()
     * @generated
     */
    int FOREIGN_AUTHOR = 3;

    /**
     * The feature id for the '<em><b>Name</b></em>' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOREIGN_AUTHOR__NAME = AUTHOR__NAME;

    /**
     * The number of structural features of the '<em>Foreign Author</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int FOREIGN_AUTHOR_FEATURE_COUNT = AUTHOR_FEATURE_COUNT + 0;

    /**
     * The meta object id for the '{@link test.saveref.impl.RootImpl <em>Root</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see test.saveref.impl.RootImpl
     * @see test.saveref.impl.SaverefPackageImpl#getRoot()
     * @generated
     */
    int ROOT = 4;

    /**
     * The feature id for the '<em><b>Authors</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROOT__AUTHORS = 0;

    /**
     * The feature id for the '<em><b>Books</b></em>' containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROOT__BOOKS = 1;

    /**
     * The number of structural features of the '<em>Root</em>' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     * @ordered
     */
    int ROOT_FEATURE_COUNT = 2;


    /**
     * Returns the meta object for class '{@link test.saveref.Book <em>Book</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Book</em>'.
     * @see test.saveref.Book
     * @generated
     */
    EClass getBook();

    /**
     * Returns the meta object for the attribute '{@link test.saveref.Book#getName <em>Name</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Name</em>'.
     * @see test.saveref.Book#getName()
     * @see #getBook()
     * @generated
     */
    EAttribute getBook_Name();

    /**
     * Returns the meta object for class '{@link test.saveref.ScifiBook <em>Scifi Book</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Scifi Book</em>'.
     * @see test.saveref.ScifiBook
     * @generated
     */
    EClass getScifiBook();

    /**
     * Returns the meta object for the reference list '{@link test.saveref.ScifiBook#getAuthors <em>Authors</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the reference list '<em>Authors</em>'.
     * @see test.saveref.ScifiBook#getAuthors()
     * @see #getScifiBook()
     * @generated
     */
    EReference getScifiBook_Authors();

    /**
     * Returns the meta object for class '{@link test.saveref.Author <em>Author</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Author</em>'.
     * @see test.saveref.Author
     * @generated
     */
    EClass getAuthor();

    /**
     * Returns the meta object for the attribute '{@link test.saveref.Author#getName <em>Name</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the attribute '<em>Name</em>'.
     * @see test.saveref.Author#getName()
     * @see #getAuthor()
     * @generated
     */
    EAttribute getAuthor_Name();

    /**
     * Returns the meta object for class '{@link test.saveref.ForeignAuthor <em>Foreign Author</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Foreign Author</em>'.
     * @see test.saveref.ForeignAuthor
     * @generated
     */
    EClass getForeignAuthor();

    /**
     * Returns the meta object for class '{@link test.saveref.Root <em>Root</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for class '<em>Root</em>'.
     * @see test.saveref.Root
     * @generated
     */
    EClass getRoot();

    /**
     * Returns the meta object for the containment reference list '{@link test.saveref.Root#getAuthors <em>Authors</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the containment reference list '<em>Authors</em>'.
     * @see test.saveref.Root#getAuthors()
     * @see #getRoot()
     * @generated
     */
    EReference getRoot_Authors();

    /**
     * Returns the meta object for the containment reference list '{@link test.saveref.Root#getBooks <em>Books</em>}'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the meta object for the containment reference list '<em>Books</em>'.
     * @see test.saveref.Root#getBooks()
     * @see #getRoot()
     * @generated
     */
    EReference getRoot_Books();

    /**
     * Returns the factory that creates the instances of the model.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @return the factory that creates the instances of the model.
     * @generated
     */
    SaverefFactory getSaverefFactory();

    /**
     * <!-- begin-user-doc -->
     * Defines literals for the meta objects that represent
     * <ul>
     *   <li>each class,</li>
     *   <li>each feature of each class,</li>
     *   <li>each enum,</li>
     *   <li>and each data type</li>
     * </ul>
     * <!-- end-user-doc -->
     * @generated
     */
    interface Literals {
        /**
         * The meta object literal for the '{@link test.saveref.impl.BookImpl <em>Book</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see test.saveref.impl.BookImpl
         * @see test.saveref.impl.SaverefPackageImpl#getBook()
         * @generated
         */
        EClass BOOK = eINSTANCE.getBook();

        /**
         * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute BOOK__NAME = eINSTANCE.getBook_Name();

        /**
         * The meta object literal for the '{@link test.saveref.impl.ScifiBookImpl <em>Scifi Book</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see test.saveref.impl.ScifiBookImpl
         * @see test.saveref.impl.SaverefPackageImpl#getScifiBook()
         * @generated
         */
        EClass SCIFI_BOOK = eINSTANCE.getScifiBook();

        /**
         * The meta object literal for the '<em><b>Authors</b></em>' reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference SCIFI_BOOK__AUTHORS = eINSTANCE.getScifiBook_Authors();

        /**
         * The meta object literal for the '{@link test.saveref.impl.AuthorImpl <em>Author</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see test.saveref.impl.AuthorImpl
         * @see test.saveref.impl.SaverefPackageImpl#getAuthor()
         * @generated
         */
        EClass AUTHOR = eINSTANCE.getAuthor();

        /**
         * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EAttribute AUTHOR__NAME = eINSTANCE.getAuthor_Name();

        /**
         * The meta object literal for the '{@link test.saveref.impl.ForeignAuthorImpl <em>Foreign Author</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see test.saveref.impl.ForeignAuthorImpl
         * @see test.saveref.impl.SaverefPackageImpl#getForeignAuthor()
         * @generated
         */
        EClass FOREIGN_AUTHOR = eINSTANCE.getForeignAuthor();

        /**
         * The meta object literal for the '{@link test.saveref.impl.RootImpl <em>Root</em>}' class.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @see test.saveref.impl.RootImpl
         * @see test.saveref.impl.SaverefPackageImpl#getRoot()
         * @generated
         */
        EClass ROOT = eINSTANCE.getRoot();

        /**
         * The meta object literal for the '<em><b>Authors</b></em>' containment reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference ROOT__AUTHORS = eINSTANCE.getRoot_Authors();

        /**
         * The meta object literal for the '<em><b>Books</b></em>' containment reference list feature.
         * <!-- begin-user-doc -->
         * <!-- end-user-doc -->
         * @generated
         */
        EReference ROOT__BOOKS = eINSTANCE.getRoot_Books();

    }

} //SaverefPackage
